import time, sys, array, operator

if len(sys.argv) < 2:
  print "Usage: convertMd5.py oldMd5file [num_words]"
  sys.exit()

print "Reading Md5 Lookup File"
md5file = open(sys.argv[1], "r")
ymappingFile = open(sys.argv[1] + ".map","w")
num_words = 3
if len(sys.argv) > 2:
    num_words = int(sys.argv[2])
print "Each entry is ",16 + num_words * 2,"bytes long"

startTime = time.time()
line = md5file.readline()
wordDict = {}
md5Dict = {}
while line != "":
  md5, answer = line.replace("\n","").split(" ")
  if answer.find("_") != -1:
    answer = answer.split("_")
    print answer

  firstHalf = int(md5[0:16],16)
  secondHalf = int(md5[16:32],16) #Stupid array won't take a 16 byte long
  answerIndices = []
  for word in answer:
    if word != "":
      if word not in wordDict:
        ymappingFile.write(word + "," + str(len(wordDict)) + "\n")
        print "Added",word,"at index",len(wordDict)
        wordDict[word] = len(wordDict)
      answerIndices.append(wordDict[word])
  if len(answerIndices) != num_words: #Don't worry about captchas that aren't 12 words long
    line = md5file.readline()
    continue

  if firstHalf not in md5Dict:
    md5Dict[firstHalf] = {}
  md5Dict[firstHalf][secondHalf] = answerIndices

  if len(md5Dict) % 100000 == 0:
    print "Loaded", len(md5Dict), "md5s"

  line = md5file.readline()

readTime = time.time()
print "Done reading",sys.argv[1] + ".  Found", len(md5Dict),"md5s. It took",str(readTime-startTime)

md5Dict = sorted(md5Dict.iteritems(), key=operator.itemgetter(0)) #Sort the md5 files

sortTime = time.time()
print "Done sorting",sys.argv[1] + ".  It took",str(sortTime-readTime)

convertedFile = open(sys.argv[1] + ".small","wb")
for firstHalf, rest in md5Dict:
  sorted_rest = sorted(rest.iteritems(), key=operator.itemgetter(0))
  for secondHalf, answer in sorted_rest:
    md5data = array.array('L')
    md5data.append(firstHalf)
    md5data.append(secondHalf)

    answerdata = array.array('H')
    for wordIndex in answer:
      answerdata.append(wordIndex)
    md5data.tofile(convertedFile)
    answerdata.tofile(convertedFile)

md5file.close()
convertedFile.close()
ymappingFile.close()

print "Done writing",sys.argv[1] + ".map.  It took",str(time.time() - sortTime)
print "Converting Md5 Lookup File took %f seconds total" % (time.time() - startTime)

