import logging, time, subprocess, argparse, sys, random
from downloaderbase import DownloaderBase

class NucaptchaDownloader(DownloaderBase):
    classname = "NucaptchaDownloader"
    site_key = ""

    download_url = 'http://docs.nucaptcha.com/embed/basic2/outdoor_2'
    referer = 'http://docs.nucaptcha.com/embed/basic2/outdoor_2'
    submit_url = 'http://docs.nucaptcha.com/embed/basic2/outdoor_2'     
    challenge_field = "nucaptcha-fallback-token"
    answer_field = "nucaptcha-answer"

    def get_audio_url_and_challenge(self):
        output = self.get_url(self.download_url, True)
        self.index = str(random.randint(0,4)) #they only give us so many, so we have to go to the second index to get more.  You don't really need this
        challenge = self.find_string(output, '/?token=', '&')
        url = self.find_string(output, 'no-repeat center center;" class="" src="', '"')
        url = url.replace("GIF", "MP3")
        url = url.replace("index=0", "index=" + self.index)
        return challenge, url 
                
    def submit_captcha(self, challenge, answer):
        other_data =   "nucaptcha-answer-enter" + str(time.time() - 8)
        other_data += "&nucaptcha-answer-exit"  + str(time.time())
        other_data += "&lmsubmitted=1"
        other_data += "&nucaptcha-index=" + self.index
        other_data += "&nucaptcha-datatype=MP3"
        other_data += "&nucaptcha-ptype=FLASH"
        other_data += "&nucaptcha-language=end"
        other_data += "&nucaptcha-region=east1"
        other_data += "&nucaptcha-media-download-time=" + str(random.randint(1000, 1070))
        other_data += "&nucaptcha-adserv-download-time=" + str(random.randint(500,700))
        other_data += "&nucaptcha_embed_submit=Submit"
        response = self.respond_to_captcha(challenge, answer, other_data)
        return response.find("Please try again") == -1

