from downloaderbase import DownloaderBase

class PaypalDownloader(DownloaderBase):
    classname = "PaypalDownloader"
    site_key = ""
    download_url = "https://www.paypal.com/cgi-bin/webscr?cmd=_email-recovery"
    referer = "https://www.paypal.com/cgi-bin/webscr?cmd=_email-recovery"
    challenge_field = "CONTEXT"
    answer_field = "securityCode"

    filetype = "WAVE"
    fileext= ".wav"

    def get_audio_url_and_challenge(self):
        output = self.get_url(self.download_url, True)
        url = self.find_string(output, '<div class="clear"><p><img src="https://www.paypal.com/cgi-bin/', '"')
        url = url.replace(".jpeg",".wav").replace("gs_web","wv_web") 

        challenge = self.find_string(output, 'name="CONTEXT" value="', '"')
        self.submit_url = self.find_string(output, '"ForgotYourEmailAddress" action="', '"')
        return challenge, "https://www.paypal.com/cgi-bin/" + url
    
    def submit_captcha(self, challenge, answer):
        other_data =  "myAllTextSubmitID=&cmd=_flow&first_name=Dade&last_name=Murphy"
        other_data += "&zip_code=13337&telephone=5550212&fin_instrument=no&digits=&myAllTextSubmitID=&submit.x=Submit&form_charset=UTF-8"
        response = self.respond_to_captcha(challenge, answer, other_data)
        if response.find("did not find a PayPal account which matches the information") != -1 or response.find("No Match Found") != -1:
            return True #Good captcha
        elif response.find("Security Measure: Please type the characters you see into the field.") != -1:
            return False #Bad captcha
        datafile=open("datafile","w")
        datafile.write(response)
        datafile.close()
        sys.exit()
        return None 

    
