import argparse, os, sys

parser = argparse.ArgumentParser(description="Moves and renames all the wavs in the format inputdir/captcha####-word_word..._word.mp3 into the outputdir/word/captca###.wav format")
parser.add_argument('inputdir', help='The directory to find all the wavs to move and rename')
parser.add_argument('outputdir', help='The directory to find all the wavs to move and rename')
args = parser.parse_args()

if args.inputdir[-1] != "/":
    args.inputdir += "/"
if args.outputdir[-1] != "/":
    args.outputdir += "/"

filenames = os.listdir(args.inputdir)
filenames.sort()
for filename in filenames:
    if filename.find("wav") == -1:
        continue

    parts = filename.replace(".mp3","").replace(".wav","").split("-")
    if len(parts) == 1:
        continue

    captcha_number = parts[0]
    subparts = parts[1].split("_")
    answer_parts = subparts[:-1]
    try:
        word_index = int(subparts[-1])
    except:
        continue #The image wasn't of just a word, so don't bother with it
    if word_index > len(answer_parts) - 1: #The answer doesn't have the necessary words
        continue

    answer = answer_parts[word_index]
    if not os.path.exists(args.outputdir + answer):
        os.mkdir(args.outputdir + answer)
    os.rename(args.inputdir + filename, args.outputdir + answer + "/" + captcha_number + "_" + str(word_index) + ".wav") 
    print "Moving",args.inputdir + filename," to ", args.outputdir + answer + "/" + captcha_number + "_" + str(word_index) + ".wav"
